unit {%unitname};
{%contact}
interface
uses Classes, SysUtils{<tree}, ComCtrls{>tree};
type
  {%keys}
type
  TOp = (Nop, UseCase, NoCase,
         SDSet, SXSet, SSet, SESet, SDESet, SXESet,
         MDSet, MXSet, MSet, MESet, MDESet, MXESet);
  TICell = record
    Nha, Nva: Integer;
    Ch: Char;
    Op: TOp;
    K: TKey;
  end;
  TPos = record
    Ln, P, Len: Integer;
  end;
  PPos = ^TPos;
  TKWrec = record
    k: TKey;
    Lp: TPos;
    Nch: boolean;
  end;
  TKeySet = set of TKey;
{<list}
  TListObj = record
    K: TKey;
    Lp: TPos;
  end;
  PListObj = ^TListObj;
  TExchImage = function(Imgx: string): string;
  TExchKeyImage = function(Kx: TKey; Imgx: string): string;
{>list}
{<copy}
  TCopyProc = procedure (KeyImage: string);
{>copy}
const
  TopSt=127;
  {#-}
  {%cset}
  {%clex}
  {%cdxchar}
  {#+}
{<ccomp}
type
{%compname} = class(TComponent)
    private
{>ccomp}
{<cunit}
var
{>cunit}
      KwStack: array [0..TopSt] of TKWrec;
      KwIdx: Integer;
      Lnx: TStringList;
      Img: string;
      Lp: TPos;
      LpStack: array [0..TopSt] of TPos;
      LpIdx: Integer;
      Fname: string;
      NextChar: Boolean;
      UseLastKey: Boolean;
      LastKey: TKey; 
      pStart: TPos;
{<list}
      KeyWordList: TStringList;
      KWLIndex: Integer;
{>list}
{<ccomp}
    protected
    public
{>ccomp}
      procedure Init(FileName: String);
      function Key: TKey;
      function Image: String;
{<skip}
      function Skip(ToKey: TKey): TKey;
      function SkipSet(ToKeys: TKeySet): TKey;
      function SkipWhile(InKeySet: TKeySet): TKey;
{>skip}
{<copy}
      function SkipCopy(ToKey: TKey; CopyProc: TCopyProc): TKey;
      function SkipSetCopy(ToKeys: TKeySet; CopyProc: TCopyProc): TKey;
      function SkipWhileCopy(InKeySet: TKeySet; CopyProc: TCopyProc): TKey;
{>copy}
{<list}
      procedure ConvertToList;
{<clean}
      procedure RemoveBlanks;
      procedure RemoveEoln;
      procedure Remove(K: TKey);
      procedure RemoveSet(KSet: TKeySet);
{>clean}
{<save}
      procedure SaveList(FileName: string);
{>save}
{<lfunc}
      function ListFirst: TKey;
      function ListPrev: TKey;  overload;
      function ListPrev(K: TKey): TKey;  overload;
      function ListPrev(KSet: TKeySet): TKey;  overload;
      function ListNext: TKey;  overload;
      function ListNext(K: TKey): TKey;  overload;
      function ListNext(KSet: TKeySet): TKey;  overload;
      function ListLast: TKey;
      function ListKey: TKey;
      function ListLinePos: TPos;
      function ListImage: String;
      function ListIndex: Integer;
      procedure ListSetIndex(Idx: Integer);
      procedure ListDelete;
      procedure ListInsert(K: TKey; KeyImage: string);
      procedure ListExchImage(NewImage: string);
      procedure ListExchKey(NewKey: TKey);
      procedure ListExchPos(NewPos: TPos);
      procedure ListFree;
      procedure ListClear;
{>lfunc}
{<lgroup}
      function ListGroup(KeyList: array of TKey; ResultKey: TKey): boolean;
      function ListExchImageAll(InKeySet: TKeySet; ExchImg: TExchImage): Boolean;
      function ListExchKeyImageAll(InKeySet: TKeySet; ExchKeyImg: TExchKeyImage): Boolean;

{>lgroup}
{>list}
{<tree}
      procedure ShowTree(Tv: TTreeView);
{>tree}
{<ccomp}
  end;

procedure Register; 
{>ccomp}

implementation

{<list}
var
  PLObj: PListObj;

{>list}
{<ccomp}
procedure Register;
begin
  RegisterComponents({%page}, [{%compname}]);
end;
{>ccomp}

function {<ccomp}{%compname}.{>ccomp}Image: string;
  begin
    result := Img;
  end;
procedure {<ccomp}{%compname}.{>ccomp}Init(FileName: String);
  var
    f: TextFile;
    ws: string;
    L: Integer;
  begin
    KwStack[0].Lp.Ln := -1;    KwStack[0].Lp.p := -1;
    if Lnx = nil then Lnx := TStringList.Create
    else Lnx.Clear;
    AssignFile(f, FileName);  Reset(f);
    while not eof(f) do
      begin
        readln(f, ws);          L := Length(ws);
        while (L > 0) and (ws[L] in [' ', #9]) do dec(L);
        Lnx.Add(Copy(ws, 1, L) + #10);
      end;
    Lnx.Add(#26);
    CloseFile(f);
    NextChar := true;        UseLastKey := False;      LastKey := kundef;
    Lp.Ln := 0;              Lp.P := 0;
    Lp.Len := Length(Lnx.Strings[Lp.Ln]);
  end;


  function {<ccomp}{%compname}.{>ccomp}Key: TKey;
  label MD1, MD2, MD3, MD4;
  var
    L, P, N: Integer;
    bs: array [0..TopSt] of TICell;
    Qx, Stop: Boolean;
    ch: Char;
    w1: String[1];

  function Chx: Char;
  begin
    if NextChar then
      begin
        Inc(Lp.P);
        if Lp.p > Lp.Len then
          begin
            Inc(Lp.Ln); Lp.P := 1;
            Lp.Len := Length(Lnx.Strings[Lp.Ln]);
          end;
      end
    else NextChar := True;
    result := Lnx.Strings[Lp.Ln][Lp.P];
  end;

  function DTest(ch: Char): Boolean;
  begin
    result := false;
    if Lp.P < Lp.Len then
      begin
        if (ch = Lnx.Strings[Lp.Ln][Lp.p]) and
           (ch = Lnx.Strings[Lp.Ln][Lp.p+1]) then
          begin
            Inc(Lp.p);  result := true;
          end;
      end;
  end;

  function XTest(ch: Char): Boolean;
  begin
    result := false;
    if Lp.P < Lp.Len then
      begin
        if (ch = Lnx.Strings[Lp.Ln][Lp.p]) then
          begin
            Inc(Lp.p);  result := true;
          end;
      end;
  end;

  procedure SaveKey;
  begin
    inc(KwIdx);  KwStack[KwIdx].k := Bs[n].k;  KwStack[KwIdx].Lp := Lp;
    KwStack[KwIdx].Nch := NextChar;
  end;

  function RestoreKey: TKey;
  var
    N, M, TopPos: Integer;
    function LPos(m: Integer): Integer;
    begin
      if KwStack[m].NCh then result := KwStack[m].Lp.P
      else result := KwStack[m].Lp.p-1;
    end;
  begin
    M := KwIdx;
    if KwIdx > 1 then
      begin
        TopPos := LPos(KwIdx);
        N := KwIdx - 1;
        while LPos(N) = TopPos do
          begin
            M := n;         Dec(n);
          end;
      end;
    result := KwStack[m].k;
    Lp := KwStack[m].Lp;
    NextChar := KwStack[m].NCh;
  end;

  begin
    if UseLastKey then
      begin
        result := LastKey;  UseLastKey := false;  exit;
      end;
    if LastKey = keof then
      begin
        result := LastKey;     exit;
      end;
    N := 0;          bs[0] := CLex[0];      Result := kundef;
    Stop := False;   Img := '';
    LpIdx := 0;      LpStack[LpIdx] := Lp;
    KwIdx := 0;
    {%skipset}
    pStart := Lp;
    if NextChar then
      begin
        Inc(PStart.P);
        if PStart.p > PStart.Len then
          begin
            Inc(PStart.Ln); PStart.P := 1;
            PStart.Len := Length(Lnx.Strings[PStart.Ln]);
          end;
      end;
    repeat
      ch := chx;  qx := false;
      case Bs[n].Op of
        UseCase:
          if Bs[n].Ch = Ch then qx := true
          else NextChar := false;
        NoCase:
          begin
            w1 := AnsiLowerCase(Ch);
            if Bs[n].Ch = w1[1] then qx := true
            else NextChar := false;
          end;
        SDSet:
          if DTest(CDXChar[Bs[n].Ch]) then qx := true
          else if ch in CSet[Bs[n].Ch] then qx := true
          else NextChar := false;
        SXSet:
          if XTest(CDXChar[Bs[n].Ch]) then qx := true
          else if ch in CSet[Bs[n].Ch] then qx := true
          else NextChar := false;
        SSet:
          if ch in CSet[Bs[n].Ch] then qx := true
          else NextChar := false;
        SESet:
          begin
            NextChar := ch in CSet[Bs[n].Ch];
            qx := True;
          end;
        SDESet:
          begin
            qx := true;
            if not DTest(CDXChar[Bs[n].Ch]) then
              NextChar := ch in CSet[Bs[n].Ch];
          end;
        SXESet:
          begin
            qx := true;
            if not XTest(CDXChar[Bs[n].Ch]) then
              NextChar := ch in CSet[Bs[n].Ch];
          end;
        MDSet:
          begin
            MD1:
            if DTest(CDXChar[Bs[n].Ch]) then
              begin
                qx := true;   ch := chx;   goto MD1;
              end;
            if ch in CSet[Bs[n].Ch] then
              begin
                while ch in CSet[Bs[n].Ch] do ch := chx;
                Qx := True;   goto MD1;
              end
            else NextChar := False;
          end;
        MXSet:
          begin
            MD2:
            if XTest(CDXChar[Bs[n].Ch]) then
              begin
                qx := true;   ch := chx;   goto MD2;
              end;
            if ch in CSet[Bs[n].Ch] then
              begin
                while ch in CSet[Bs[n].Ch] do ch := chx;
                Qx := True;   goto MD2;
              end
            else NextChar := False;
          end;
        MSet:
          if ch in CSet[Bs[n].Ch] then
            begin
              while ch in CSet[Bs[n].Ch] do ch := chx;
              NextChar := False;    Qx := True; {?}
            end
          else NextChar := False;
        MESet:
          begin
            while ch in CSet[Bs[n].Ch] do ch := chx;
            NextChar := False;    Qx := True; {?}
          end;
        MDESet:
          begin
            MD3:
            if DTest(CDXChar[Bs[n].Ch]) then
              begin
                ch := chx;   goto MD3;
              end;
            if ch in CSet[Bs[n].Ch] then
              begin
                while ch in CSet[Bs[n].Ch] do ch := chx;
                goto MD3;
              end;
            NextChar := False;    Qx := True;
          end;
        MXESet:
          begin
            MD4:
            if XTest(CDXChar[Bs[n].Ch]) then
              begin
                ch := chx;   goto MD4;
              end;
            if ch in CSet[Bs[n].Ch] then
              begin
                while ch in CSet[Bs[n].Ch] do ch := chx;
                goto MD4;
              end;
            NextChar := False;    Qx := True;
          end;
        else qx := false;
      end;
      if qx then
        begin
          if Bs[n].K <> kundef then Savekey;
          if Bs[n].Nha = 0 then
            begin
              result := Bs[n].K;  Stop := True;
            end
          else
            begin
              Bs[n+1] := CLex[Bs[n].Nha];  Inc(n);
              Inc(LpIdx);
              if LpIdx > TopSt then
                raise exception.Create('LEX Error: Stack overflow' +
                #10#12 + 'Change TopST');
              LpStack[LpIdx] := Lp;
            end;
        end
      else if Bs[n].Nva <> 0 then
        begin
          Bs[n] := CLex[Bs[n].Nva];  NextChar := False;
        end
      else
        begin
          while n > 0 do
            begin
              Lp := LpStack[LpIdx];        Dec(LpIdx);
              if LpIdx < 0 then
                raise exception.Create('LEX internal error: Stack overflow [' +
                IntToStr(LpIdx) + ']');
              Dec(n);
              if bs[n].Nva <> 0 then break;
            end;
          if bs[n].Nva <> 0 then
            begin
              Bs[n] := CLex[Bs[n].Nva];       NextChar := False;
            end
          else
            begin
              result := kundef;   Stop := True;     NextChar := true;
            end;
        end;
    until Stop;
    if KwIdx > 1 then Result := RestoreKey
    else if KwIdx = 1 then
      begin
        result := KwStack[1].k;
        Lp := KwStack[1].Lp;
        NextChar := KwStack[1].NCh;
      end;
    if NextChar then p := Lp.P
    else p := Lp.p-1;
    for l := PStart.P to P do
      Img := Img + Lnx.Strings[Lp.Ln][L];
    LastKey := Result;
  end;

{<tree}
procedure {<ccomp}{%compname}.{>ccomp}ShowTree(Tv: TTreeView);
var
  Nd: TTreeNode;
  function OpImage(Op: TOp): string;
  begin
    case Op of
      Nop: result := '   [Nop]';
      UseCase: result := '   [UseCase]';
      NoCase: result := '   [NoCase]';
      SDSet: result := '   [SDSet]';
      SXSet: result := '   [SXSet]';
      SSet: result := '   [SSet]';
      SESet: result := '   [SESet]';
      SDESet: result := '   [SDESet]';
      SXESet: result := '   [SXESet]';
      MDSet: result := '   [MDSet]';
      MXSet: result := '   [MXSet]';
      MSet: result := '   [MSet]';
      MESet: result := '   [MESet]';
      MDESet: result := '   [MDESet]';
      MXESet: result := '   [MXESet]';
      else result := '   [error]';
    end;
  end;
  function Imx(Ch: Char): string;
  begin
    if ch < #32 then
      result := '#' + IntToStr(Ord(ch)) + ' '
    else if ch = '''' then result := ' '' '
    else result := ' ' + ch + ' ';
  end;
  procedure addNode(Nx: TTreeNode; Ref: Integer; Child: Boolean);
  var
    newNx: TTreeNode;
    function Txt: string;
    begin
      result := Imx(CLex[Ref].ch) + OpImage(CLex[Ref].Op) +
                KwImage[CLex[Ref].k];
    end;
  begin
    if child then NewNx := Nx.Owner.AddChild(Nx, txt)
    else NewNx := Nx.Owner.Add(Nx, txt);
    if CLex[Ref].Nha <> 0 then addNode(NewNx, CLex[Ref].Nha, true);
    if CLex[Ref].Nva <> 0 then addNode(NewNx, CLex[Ref].Nva, false);
  end;
begin
  Nd := tv.Items.Add(nil, Imx(CLex[0].ch) + OpImage(CLex[0].Op) +
                     KwImage[CLex[0].k]);
  if Clex[0].Nha <> 0 then addNode(Nd, Clex[0].Nha, true);
  if Clex[0].Nva <> 0 then addNode(Nd, Clex[0].Nva, false);
  Nd.Expand(true);
end;
{>tree}

{<skip}
function {<ccomp}{%compname}.{>ccomp}Skip(ToKey: TKey): TKey;
var
  kwset : TKeySet;
begin
  KwSet := [ToKey, keof];
  while not (key in KwSet) do ;
  result := LastKey;
end;
function {<ccomp}{%compname}.{>ccomp}SkipSet(ToKeys: TKeySet): TKey;
begin
  while not (key in ToKeys) do ;
  result := LastKey;
end;

function {<ccomp}{%compname}.{>ccomp}SkipWhile(InKeySet: TKeySet): TKey;
var
  LastKw: TKey;
begin
  LastKw := TKey(0);
  while not (key in InKeySet) do LastKw := LastKey;
  result := LastKw;   UseLastKey := True;
end;
{>skip}
{<copy}
function {<ccomp}{%compname}.{>ccomp}SkipCopy(ToKey: TKey; CopyProc: TCopyProc): TKey;
var
  kwset : TKeySet;
begin
  KwSet := [ToKey, keof];
  while not (key in KwSet) do CopyProc(Img);
  result := LastKey;
end;

function {<ccomp}{%compname}.{>ccomp}SkipSetCopy(ToKeys: TKeySet; CopyProc: TCopyProc): TKey;
begin
  while not (key in ToKeys) do CopyProc(Img);
  result := LastKey;
end;

function {<ccomp}{%compname}.{>ccomp}SkipWhileCopy(InKeySet: TKeySet; CopyProc: TCopyProc): TKey;
var
  LastKw: TKey;
begin
  LastKw := TKey(0);
  while not (key in InKeySet) do
    begin
      LastKw := LastKey;  CopyProc(Img);
    end;
  result := LastKw;   UseLastKey := True;
end;
{>copy}
{<list}
procedure {<ccomp}{%compname}.{>ccomp}ConvertToList;
var
  i: Integer;
begin
  if KeyWordList = nil then KeyWordList := TStringList.Create
  else
    begin
      for i := 0 to KeyWordList.Count-1 do
        begin
          dispose(PListObj(KeyWordList.Objects[i]));
          KeyWordList.Objects[i] := nil;
        end;
      KeyWordList.Clear;
    end;
  KWLIndex := 0;
  while key <> keof do
      {<remb}
    if Image[1] = ' ' then
    else
      {>remb}
      {<remt}
    if Image[1] = #9 then
    else
      {>remt}
      {<reme}
    if Image[1] = #10 then
    else
      {>reme}
    begin
      New(PLObj);  PLObj^.K := LastKey;  PLObj^.Lp := pStart;
      KeyWordList.AddObject(Image, TObject(PLObj));
    end;
  New(PLObj);  PLObj^.K := LastKey;  PLObj^.Lp := pStart;
  KeyWordList.AddObject(Image, TObject(PLObj));
end;

{<clean}
procedure {<ccomp}{%compname}.{>ccomp}RemoveBlanks;
var
  i: Integer;

  procedure CheckRem(Ii: Integer);
  var
    j: Integer;
  begin
    for J := 1 to Length(KeyWordList[ii]) do {??? Tabs}
      if KeyWordList[ii][j] <> ' ' then exit;
    KeyWordList.delete(ii);
  end;

begin
  for i := KeyWordList.Count-1 downto 0 do
    if KeyWordList[i][1] = ' ' then CheckRem(i);
end;

procedure {<ccomp}{%compname}.{>ccomp}RemoveEoln;
var
  i: Integer;
begin
  for i := KeyWordList.Count-1 downto 0 do
    if KeyWordList[i][1] = #10 then KeyWordList.Delete(i);
end;

procedure {<ccomp}{%compname}.{>ccomp}Remove(K: TKey);
var
  i: Integer;
begin
  for i := KeyWordList.Count-1 downto 0 do
    if PListObj(KeyWordList.Objects[I])^.K = K then KeyWordList.Delete(i);
end;

procedure {<ccomp}{%compname}.{>ccomp}RemoveSet(KSet: TKeySet);
var
  i: Integer;
begin
  for i := KeyWordList.Count-1 downto 0 do
    if PListObj(KeyWordList.Objects[I])^.K in KSet then KeyWordList.Delete(i);
end;
{>clean}
{<save}
procedure {<ccomp}{%compname}.{>ccomp}SaveList(FileName: string);
var
  F: TextFile;
  i: Integer;
  Line: string;
begin
  AssignFile(F, FileName);   Rewrite(F);  Line := '';
  for i := 0 to KeyWordList.Count-1 do
    if KeyWordList[i][1] = #10 then
      begin
        writeln(F, Line);  Line := '';
      end
    else Line := Line + KeyWordList[i];
  { Last line contents #26 only! }
  CloseFile(F);
end;
{>save}
{<lfunc}
function {<ccomp}{%compname}.{>ccomp}ListFirst: TKey;
begin
  KWLIndex := 0;
  result := PListObj(KeyWordList.Objects[KWLIndex])^.K;
end;
function {<ccomp}{%compname}.{>ccomp}ListPrev: TKey;
begin
  if KWLIndex > 0 then dec(KWLIndex);
  result := PListObj(KeyWordList.Objects[KWLIndex])^.K;
end;

function {<ccomp}{%compname}.{>ccomp}ListPrev(K: TKey): TKey;
begin
  if KWLIndex > 0 then dec(KWLIndex);
  while (KWLIndex > 0) and
    (PListObj(KeyWordList.Objects[KWLIndex])^.K <> K) do dec(KWLIndex);
  result := PListObj(KeyWordList.Objects[KWLIndex])^.K;
  if result <> k then result := kUndef;
end;

function {<ccomp}{%compname}.{>ccomp}ListPrev(KSet: TKeySet): TKey;
begin
  if KWLIndex > 0 then dec(KWLIndex);
  while (KWLIndex > 0) and
    not (PListObj(KeyWordList.Objects[KWLIndex])^.K in KSet) do dec(KWLIndex);
  result := PListObj(KeyWordList.Objects[KWLIndex])^.K;
  if not (result in KSet) then result := kUndef;
end;

function {<ccomp}{%compname}.{>ccomp}ListNext: TKey;
begin
  if KWLIndex < (KeyWordList.Count-1) then inc(KWLIndex);
  result := PListObj(KeyWordList.Objects[KWLIndex])^.K;
end;

function {<ccomp}{%compname}.{>ccomp}ListNext(K: TKey): TKey;
begin
  if KWLIndex < (KeyWordList.Count-1) then inc(KWLIndex);
  while (KWLIndex < KeyWordList.Count-1) and
    (PListObj(KeyWordList.Objects[KWLIndex])^.K <> K) do inc(KWLIndex);
  result := PListObj(KeyWordList.Objects[KWLIndex])^.K;
  if result <> k then result := kUndef;
end;

function {<ccomp}{%compname}.{>ccomp}ListNext(KSet: TKeySet): TKey;
begin
  if KWLIndex < (KeyWordList.Count-1) then inc(KWLIndex);
  while (KWLIndex < KeyWordList.Count-1) and
    not (PListObj(KeyWordList.Objects[KWLIndex])^.K in KSet) do inc(KWLIndex);
  result := PListObj(KeyWordList.Objects[KWLIndex])^.K;
  if not (result in KSet) then result := kUndef;
end;

function {<ccomp}{%compname}.{>ccomp}ListLast: TKey;
begin
  KWLIndex := KeyWordList.Count-1;
  result := PListObj(KeyWordList.Objects[KWLIndex])^.K;
end;

function {<ccomp}{%compname}.{>ccomp}ListKey: TKey;
begin
  result := PListObj(KeyWordList.Objects[KWLIndex])^.K;
end;

function {<ccomp}{%compname}.{>ccomp}ListLinePos: TPos;
begin
  result := PListObj(KeyWordList.Objects[KWLIndex])^.Lp;
end;

function {<ccomp}{%compname}.{>ccomp}ListImage: String;
begin
  result := KeyWordList[KWLIndex];
end;

function {<ccomp}{%compname}.{>ccomp}ListIndex: Integer;
begin
  result := KWLIndex;
end;

procedure {<ccomp}{%compname}.{>ccomp}ListSetIndex(Idx: Integer);
begin
  KWLIndex := Idx;
  if KWLIndex > KeyWordList.Count-1 then
    KWLIndex := KeyWordList.Count-1
  else if KWLIndex < 0 then KWLIndex := 0;
end;
procedure {<ccomp}{%compname}.{>ccomp}ListDelete;
begin
  if assigned(KeyWordList.Objects[KWLIndex]) then
    begin
      Dispose(PListObj(KeyWordList.Objects[KWLIndex]));
      KeyWordList.Objects[KWLIndex] := nil;
    end;
  KeyWordList.Delete(KWLIndex);
  if KWLIndex > KeyWordList.Count-1 then
    KWLIndex := KeyWordList.Count-1;
end;
procedure {<ccomp}{%compname}.{>ccomp}ListInsert(K: TKey; KeyImage: string);
begin
  New(PLObj);  PLObj^.K := K;  PLObj^.Lp.Ln := 0;
  KeyWordList.InsertObject(KWLIndex, KeyImage, TObject(PLObj));
  inc(KWLIndex);
end;

procedure {<ccomp}{%compname}.{>ccomp}ListExchImage(NewImage: string);
begin
  KeyWordList[KWLIndex] := NewImage;
end;
procedure {<ccomp}{%compname}.{>ccomp}ListExchKey(NewKey: TKey);
begin
  PListObj(KeyWordList.Objects[KWLIndex])^.K := NewKey;
end;
procedure {<ccomp}{%compname}.{>ccomp}ListExchPos(NewPos: TPos);
begin
  PListObj(KeyWordList.Objects[KWLIndex])^.Lp := NewPos;
end;

procedure {<ccomp}{%compname}.{>ccomp}ListFree;
begin
  ListClear;
  if KeyWordList <> nil then KeyWordList.Free;
  KeyWordList := nil;
end;
procedure {<ccomp}{%compname}.{>ccomp}ListClear;
var
  i: Integer;
begin
  if KeyWordList = nil then exit;
  for i := 0 to KeyWordList.Count - 1 do
    if assigned(KeyWordList.Objects[i]) then
      begin
        dispose(PListObj(KeyWordList.Objects[i]));
        KeyWordList.Objects[i] := nil;
      end;
  if KeyWordList <> nil then KeyWordList.Clear;
end;
{>lfunc}
{<lgroup}
function {<ccomp}{%compname}.{>ccomp}ListGroup(KeyList: array of TKey; ResultKey: TKey): Boolean;
label Repair, NextP;
var
  i, h, p: integer;
  NewImg: String;
begin
  h := High(KeyList);
  p := -1;   result := false;
  NextP:
  inc(p);
  while PListObj(KeyWordList.Objects[P])^.K <> KeyList[0] do
    begin
      inc(p);
      if p > KeyWordList.Count-1 then goto Repair;
    end;
  for i := 1 to H do
    begin
      if (P + I) > KeyWordList.Count-1 then goto Repair;
      if PListObj(KeyWordList.Objects[P+I])^.K <> KeyList[i] then
        goto NextP;
    end;
  NewImg := KeyWordList[P];
  for i := 1 to H do
    begin
      NewImg := NewImg + KeyWordList[P+I];
      PListObj(KeyWordList.Objects[P+I])^.Lp.P := -1;
    end;
  KeyWordList[P] := NewImg;
  PListObj(KeyWordList.Objects[P])^.K := ResultKey;
  result := True;
  p := p + H;
  if P >= KeyWordList.Count-1 then goto Repair;
  goto NextP;
  Repair:
  for i := KeyWordList.Count-1 downto 0 do
    if PListObj(KeyWordList.Objects[i])^.Lp.P = -1 then
      begin
        dispose(PListObj(KeyWordList.Objects[i]));
        KeyWordList.Objects[i] := nil;
        KeyWordList.Delete(i);
      end;
end;

function {<ccomp}{%compname}.{>ccomp}ListExchImageAll(InKeySet: TKeySet; ExchImg: TExchImage): Boolean;
var
  i: Integer;
begin
  result := false;
  for i := 0 to KeyWordList.Count-1 do
    if PListObj(KeyWordList.Objects[i])^.K in InKeySet then
      begin
        KeyWordList[i] := ExchImg(KeyWordList[i]);  result := true;
      end;
end;
function {<ccomp}{%compname}.{>ccomp}ListExchKeyImageAll(InKeySet: TKeySet; ExchKeyImg: TExchKeyImage): Boolean;
var
  i: Integer;
begin
  result := false;
  for i := 0 to KeyWordList.Count-1 do
    if PListObj(KeyWordList.Objects[i])^.K in InKeySet then
      begin
        KeyWordList[i] := ExchKeyImg(PListObj(KeyWordList.Objects[i])^.K,
                          KeyWordList[i]);
        result := true;
      end;
end;
{>lgroup}
{>list}
end.
